***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2009 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************
c ### asymorb ###
c
c     Calculates asymptotic values of a given orbital at the practical
c     infinity.
c
      subroutine asymorb (nmi,psi,aorb)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      include 'commons8.inc'
      dimension psi(*),aorb(nni,4)

      jj=0
      do j=nmi-3,nmi
         itt=(j-1)*nni
         jj=jj+1
         do i=1,nni
	    kk=i+itt
	    ps1=psi(kk-nni)
            ps2=psi(kk-nni)*aorb(i,jj)
c            if (j.eq.nmi-3) then
c               print *,j,i,ps1,psi(kk),psi(kk+nni),psi(kk+2*nni)
c               print *,j,i,ps1,psi(kk),psi(kk+nni),ps2 
c            endif
	    psi(kk)=psi(kk-nni)*aorb(i,jj)
c            print *,j,i,ps1,psi(kk)
c	    psi(kk)=ps1+omega*(psi(kk)-ps1)
         enddo
      enddo

      return
      end


