***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2009 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************
c ### asymorbtail ###
c
c     Calculates and stores in orbtail asymptotic values of a given
c     orbital at the practical infinity that are used when immersed
c     orbitals are formed (see fill)

      subroutine asymorbtail (psi,aorb)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      include 'commons8.inc'
      include 'commons8a.inc'
      dimension psi(*),aorb(nni,4)

      jj=0
      ii=(mxnmu-1)*nni
      do j=mxnmu+1,mxnmu+4
         jj=jj+1
         do i=1,nni
            kk=i+ii
            orbtail(itail(1),i,j-mxnmu)=psi(kk)*aorb(i,jj)
         enddo
      enddo

      return

      end
