***************************************************************************
*                                                                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### exxalpha ###

c     Calculates exchange energy according to Xalpha scheme

      real*8 function exxalpha (psi,wgt2,rhot,rhotup,rhotdown,
     &     grhot,grhotup,grhotdown,wk0,wk1,wk2,wk3,wk4,wk5,wk6,wk7)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (const43=4.d0/3.d0)
      include 'commons8.inc'	

      dimension psi(*),wgt2(*),wk0(*),wk1(*),wk2(*),wk3(*),wk4(*),  
     &     wk5(*),wk6(*),wk7(*),  
     &     rhot(*),rhotup(*),rhotdown(*),
     &     grhot(*),grhotup(*),grhotdown(*)

      do i=1,mxsize
         rhotup(i)  =0.d0
         rhotdown(i)=0.d0
      enddo
      
c     calculate total densities due to up and down spins
      do iorb=1,norb
         if (inhyd(iorb).eq.1) goto 10
         iborb=i1b(iorb)
         isiorb=i1si(iorb)
         nmut=i1mu(iorb)
         
         call exocc (iorb,ocup,ocdown)

         call prod2 (isiorb,psi(iborb),psi(iborb),wk1)
         call scal (isiorb,ocup,wk1,ione)
         
         call prod2 (isiorb,psi(iborb),psi(iborb),wk2)
         call scal (isiorb,ocdown,wk2,ione)
       
c        store total spin densities 
         call add(isiorb,wk1,rhotup)
         call add(isiorb,wk2,rhotdown)
 10      continue
      enddo

      do i=1,mxsize
         rhotup(i)=rhotup(i)**const43
         rhotdown(i)=rhotdown(i)**const43
      enddo	  
         
      call add (mxsize,rhotdown,rhotup)

c     take care of F4 factor
      call multf4(rhotup)
         
      w=dot(mxsize,wgt2,ione,rhotup,ione)

      exxalpha=fdften(alphaf)*w

c      print *,w,exxalpha

      return
      end
