***************************************************************************
*                                                                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### fdften ###

c     Calculates coefficients appearing in LDA energy formulea.

      real*8 function fdften (alpha)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (const13=1.d0/3.d0,const32=3.d0/2.d0,const34=3.d0/4.d0,
     &     const94=9.d0/4.d0,const98=9.d0/8.d0)
      include 'commons8.inc'

      if (idftex.eq.1.or.idftex.eq.2) then
c        L.Laaksonen, P.Pyykko, D.Sundholm (Int. J.Quantum Chem. 27 (1985) 601)
c        additional factor 2**(1/3) is due to the way the total density is calculated
c        (see fldapot)

c        Becke (idftex=2)
         fdften = -alpha*const98*(three/pii)**const13*two**(const13)
      elseif (idftex.eq.3) then
c        generalized gradient approximation (GGA) (Perdew & Wang 86 )
         fdften = -const34*(three/pii)**const13

      elseif (idftex.eq.4) then
c        generalized gradient approximation (GGA) (Perdew & Wang 91 )
         fdften = -const34*(three/pii)**const13
      endif

      return
      end
