***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### nnucalc ###

c     Adjust nnu to be of the form 6k+1 and 5k+5+1 (if mcsor is chosen)

      function nnucalc(n)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      parameter (k5=5, k6=6)

c     Since in this version of the program the 7 point integration
c     formula is used the number of mesh points in the nu and mu
c     variables must be of the form 6*n+1

c     Another restriction has to be imposed on the number of points in the
c     mu variable if the mcsor scheme is to be used: nmu must be
c     of the form kN+k+1, where k=iorder/2+1 for each grid (in this program
c     iorder, i.e. the order of descritization is 8) 

c     adjust, if necessary, the number of grid points in nu variable

 12   nk=(n-1)/k6
      if (k6*nk.ne.n-1) then
         n=n-1
         goto 12
      endif

      ntemp=n
      
      if (ipoiss.eq.2.and.iorder(ngrids).ne.3) then
 22      nk=(n-6)/k5
         if (k5*nk.ne.n-k5-1) then
            n=n-1
            goto 22
         endif
      endif

      if (n.gt.1.and.n.ne.ntemp) goto 12
      if (n.eq.1) then
         write(*,*) 'Error: cannot find commensurate grid size in nu'
         stop 'nnucalc'
      endif

      nnucalc=n

      return
      end
