***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### orbAsymptSet ###
c
c     Recalculates asymptotic values of a given orbital at the practical
c     infinity using exponential decay values prepared by calling orbAsymptDet.
c
      subroutine orbAsymptSet (nmi,psi,edecay)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension psi(*),edecay(nni,4)

      jj=0
      do j=nmi-3,nmi
         itt=(j-1)*nni
         jj=jj+1
         do i=1,nni
	    kk=i+itt
	    psi(kk)=psi(kk-nni)*edecay(i,jj)
         enddo
      enddo

      return
      end


