***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### potAsymptAll ###
c
c     Determines asymptotic (boundary) values of Coulomb and exchange
c     potentials from multipole expansion.

      subroutine potAsymptAll (pot,excp)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*),excp(*)

      do iorb=1,norb
         if (itouch(iorb).eq.1) then	
	    ibeg=i2b(iorb)
	    call coulAsympt(iorb,pot(ibeg))
         endif	    
      enddo 	

      if (iform.eq.0.or.iform.eq.2) return
      if (islat.eq.1) return

      do iorb1=1,norb
         do iorb2=iorb1,norb
            if (itouch(iorb1).eq.0.and.itouch(iorb2).eq.0) goto 10
            if (iorb1.eq.iorb2.and.mgx(6,iorb1).eq.0 ) goto 10
            if ((iorb1.eq.iorb2).and.(ilc(iorb1*(iorb1+1)/2).lt.1)) 
     &           goto 10
c           orbitals in increasing order
            ipc=iorb1+iorb2*(iorb2-1)/2
            iax=i3b(ipc)
c
            idel=abs(mgx(6,iorb1)-mgx(6,iorb2))
            if (iorb1.eq.iorb2) idel=2*mgx(6,iorb1)

            ido=0
 1234       ido=ido+1
            if (ido.eq.2) then
               idel=mgx(6,iorb2)+mgx(6,iorb1)
               ipc=ipc+norb*(norb+1)/2
               iax=iax+i3si(ipc)
            endif

c           Initialize array amul which is needed to evaluate exchange potentials 
c           in the asymptotic region

            call exchAsympt (idel,ipc,excp(iax))

            if (ilc(ipc).eq.2.and.ido.eq.1) go to 1234
 10         continue
         enddo
      enddo

      return
      end
