***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### schedSOR ####

c     Assigns maxsor for each orbital every iepoch iterations

      subroutine schedsor
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)

      parameter (ibonus=3,iepoch=10,nepochs=5000)
      include 'commons8.inc'
      dimension endiff(60),index(60)
      common/sched/ orbenergy(nepochs,60),orbnorm(nepochs,60),
     &     iorbiter(60)
      
      if (mod(iscf,iepoch).eq.0) then
         i=iscf/iepoch
         do iorb=1,norb
            orbenergy(i,iorb)=eng(iorb)
            orbnorm(i,iorb)=area(iorb)
         enddo

         if (i.eq.1) then
            do iorb=1,norb
               iorbiter(iorb)=iepoch*maxsororb(iorb)
            enddo
            return
         endif

         do iorb=1,norb
            iorbiter(iorb)=iorbiter(iorb)+iepoch*maxsororb(iorb)
         enddo

         inde=0
         do iorb=1,norb
            endiff(iorb)=abs(orbenergy(i-1,iorb)-orbenergy(i,iorb))

c 
c            endiff(iorb)=abs(orbnorm(i-1,iorb)-orbnorm(i,iorb))
c            endiff(iorb)=abs(orbnorm(i,iorb)-1.d0)
         enddo

         call qsortf(norb,endiff,index)

c        every orbital gets maxsororb number ranging from maxsor2-ibonus
c        to maxsor2+ibonus according to its position in the index array

         inde=index(norb)
         indemin=index(ione)
         
         minlevel=maxsor2-ibonus
         maxlevel=maxsor2+ibonus
         nlevels=maxlevel-minlevel

         do i=1,norb
            iorb=index(i)
            maxsororb(iorb)=(norb-i)*minlevel/(norb-1)
     &                     +(i-1)*maxlevel/(norb-1)

            maxsorpot(iorb)=maxsororb(iorb)
            print *, i,iorb,maxsororb(iorb)
         enddo

         write(*,'(2i6,5i6)') iscf,i,(iorbiter(iorb),iorb=norb,1,-1)
c         write(*,'(8x,5e15.5)')         (orbnorm(i,iorb),iorb=norb,1,-1)
c         write(*,'(8x,5e15.5)')         
C$$$     &        (orbenergy(i-1,iorb)/orbenergy(i,iorb)-1.d0,iorb=1,norb)
C$$$         write(*,'(8x,5e15.5)')         
C$$$     &        (orbnorm(i-1,iorb)/orbnorm(i,iorb)-1.d0,iorb=1,norb)


         write(*,'(8x,5e15.5)')         
     &        (abs(orbenergy(i-1,iorb)-orbenergy(i,iorb)),iorb=norb,1,-1)
         write(*,'(8x,5e15.5)')         
     &        (abs(orbnorm(i-1,iorb)-orbnorm(i,iorb)),iorb=norb,1,-1)

      endif

      return
      end
