***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### setPrecision ###

c     Calculates floating-point precision and integer/real variable
c     lengths

      subroutine setPrecision
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'

c     pi from bc -l
c     scale=32
c     a(1)*4=           3.14159265358979323846264338327948
c     scale=64
c     a(1)*4=           3.14159265358979323846264338327950

      pii=atan(one)*four

c     Warning!

c     Precision calculated by the code below depends on compiler
c     optimization flags used. This routine must be compiled with the
c     minimum optimization on x86 systems to avoid reporting precision
c     of the extended IEEE 754 arithmetic.

c     When in doubt try using function DLAMCH('e') (LAPACK auxiliary routine)

      precis=one
      do i=1,10000
         precis=precis/two
         o=one+precis
         if ( o.eq.one ) goto 100
      enddo
 100  continue

c     set default lengths of integer and real constants and variables used

      i8tmp1=2**30
      i8tmp2=100000*i8tmp1
      i4tmp1=i8tmp2
      if (i4tmp1.eq.0) then
         lengthint=4
      else
         lengthint=8
      endif   

      if (precis.gt.1e-20) then
         lengthfp =8
      else
         lengthfp =16
      endif
      return
      end
