***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### slaterp ###

c     Calculates exchange potentials according to the local Slater
c     approximation

      subroutine slaterp(psi,pot,excp,f2,f4,wk0)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (const13=1.d0/3.d0)
      include 'commons8.inc'	

      dimension psi(*),pot(*),excp(*),f2(*),f4(*),wk0(*)

      if (nel.eq.1) return

      call zeroArray(mxsize,excp)

c     contributions from the local slater exchange

      do iorb1=1,norb
         iborb1=i1b(iorb1)	   	 
         ngorb1=i1si(iorb1)	 	 
         coo=occ(iorb1)
         call prodas(ngorb1,coo,psi(iorb1),psi(iorb1),excp)
      enddo

c     multiply exchange potential by f4 to make it commensurate with
c     Coulomb potential

      xa=-three/two*alphaf*(three/pii)**const13

      do i=1,mxsize
         excp(i)=xa*f4(i)*(excp(i))**const13
      enddo		

      return
      end
