***************************************************************************
*                                                                         *
*   Copyright (C) 1992 F.A. Parpia and I.P. Grant                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### zgsz1g ###
c
c     Evaluate the model HF potential according to the formula derived by 
c     Green, Sellin, Zachor (Phys. Rev. 184 (1969) 1) using Z1 centre
c     with Z1 modified according to the Gauss nucleus model

      function zgsz1g(i,j)
      implicit integer*4 (i-n)
      implicit real*8 (A-H, O-Z)
      include 'commons8.inc'

      ri = r*(vxi(i)+veta(j))/two
      izz1=nint(z1)
      if (izz1.eq.0) then
         zgsz1g=0d0
         return
      endif

      if (izz1.eq.1) then
         hc=dgsz(izz1)*(z1)**0.4d0
         zgsz1g=(z1)/(hc*(exp(ri/dgsz(izz1))-one)+one)+one
         return
      endif

      zz1t=zz1g(i,j)
      if (zz1t.eq.zero) then
         zgsz1g=zero
         return
      endif

      hc=dgsz(izz1)*(zz1t-one)**0.4d0
      zgsz1g=(zz1t-one)/(hc*(exp(ri/dgsz(izz1))-one)+one)+one

      return
      end
