***************************************************************************
*                                                                         *
*   Copyright (C) 1992 F.A. Parpia and I.P. Grant                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### zgsz2g ###
c
c     Evaluate the model HF potential according to the formula derived by 
c     Green, Sellin, Zachor (Phys. Rev. 184 (1969) 1) using Z2 centre
c     with Z2 modified according to the Gauss nucleus model

      function zgsz2g(i,j)
      implicit integer*4 (i-n)
      implicit real*8 (A-H, O-Z)
      include 'commons8.inc'

      ri = r*(vxi(i)-veta(j))/two
      izz2=nint(z2)
      if (izz2.eq.0) then
         zgsz2g=0d0
         return
      endif

      if (izz2.eq.1) then
         hc=dgsz(izz2)*(z2)**0.4d0
         zgsz2g=(z2)/(hc*(exp(ri/dgsz(izz2))-one)+one)+one
         return
      endif

      zz2t=zz2g(i,j)
      if (zz2t.eq.zero) then
         zgsz2g=zero
         return
      endif

      hc=dgsz(izz2)*(zz2t-one)**0.4d0
      zgsz2g=(zz2t-one)/(hc*(exp(ri/dgsz(izz2))-one)+one)+one

      return

      end
