***************************************************************************
*                                                                         *
*   Copyright (C) 1992 F.A. Parpia and I.P. Grant                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### zz2g ###
c
c     Evaluate the nuclear potential for Gaussian models.  
c
c     This routine is based on nucpot routine from the GRASP2 package
c     (ver. 1.00, 1992)

      function zz2g(i,j)
      implicit integer*4 (i-n)
      implicit real*8 (A-H, O-Z)
      include 'commons8.inc'

      fmtoau=1.0d-13/ainfcm

      if (z2.eq.0.d0) then
         zz2g=0.d0
         eta2=1.d35
         return
      endif

c     set atomic weight 

      atw=z2atmass
      at3=atw**(one/three)
      rrmsfm = 0.836d0*at3+0.570d0

c     change units from fm into bohr

      rrms = rrmsfm*fmtoau

c     exponent of the Gaussian distribution $\rho_0 exp(-\eta r^2)$
c     rrms=(3/(2\eta)^{1/2)
      
      eta2=3.d0/(2.d0*rrms*rrms)
      
c     set the normalization constant $Z=rho_0 (pi/eta)^{3/2}$
c      rho0=z2/(pii/eta2)**1.5d0

      ri = r*(vxi(i)-veta(j))/2.d0

c      x=eta2*ri*ri
c      dg15= dgamit(1.5d0,x)*x**1.5d0*dgamma(1.5d0)  
c      zz2g = 2.0d0*pii*rho0*(dg15/eta2**1.5d0+ri*exp(-x)/eta2)
c
c     making use of F77 intrinsic function 
c     erf(x)=2/(Pi)^(1/2)*int_0^x exp(-t^2)dt
c     if available
c
      zz2g=z2*erf(sqrt(eta2)*ri)

      return
      end


